import numpy as np

# hledani minima funkce jedne promenne metodou zlateho rezu  
def minim_golden(f,a,b,c,acc,maxiter):

    R=0.38197
    
    x0=a
    x1=b
    f1=f(b)
    x3=c
    
    for iter in range(maxiter):
        # umisti dalsi delici bod
        if x1-x0 < x3-x1:
            # (x0,x1) je kratsi nez (x1,x3)
            x2=x1+R*(x3-x1)
            f2=f(x2)
        else:
            # (x0,x1) je delsi nez (x1,x3)
            x2=x1
            f2=f1
            x1=x2-R*(x2-x0)
            f1=f(x1)
           
        # vyber nove trojice bodu
        if f1<f2:
            x3=x2
            x=x1
        elif f1>f2:
            x0=x1
            x1=x2
            f1=f2
            x=x2
        else:
            break # funkce je v ramci pouzite presnosti konstantni
            
        if x3-x0<acc: break

    return x
   
#----------------------------------------------------------

def fun(x): return 0.5*x**2-np.sin(x)

x=minim_golden(fun,-5.0,0.0,+5.0,1e-4,100)
print(x)