import numpy as np
import matplotlib.pyplot as plt
import scipy.optimize

def fun(x): 
    return 0.5*x**2-np.sin(x)

x=np.linspace(-1.0,2.0,300)
y=fun(x)
plt.plot(x,y)
plt.show()

# golden section search starting with the default interval [0,1]
res=scipy.optimize.minimize_scalar(fun,method="golden")
print(res.x)

# search using the default method (brent) 
res=scipy.optimize.minimize_scalar(fun)
print(res.x)

# three points bracketing the minimum put as an optional argument
res=scipy.optimize.minimize_scalar(fun,bracket=(-1.0,0.5,2.0))
print(res.x)
print(res)